/*
  backbone-pageable
  http://github.com/wyuenho/backbone-pageable

  Copyright (c) 2012 Jimmy Yuen Ho Wong
  Licensed under the MIT @license.
*/
(function(e){if("object"==typeof exports)module.exports=e(require("underscore"),require("backbone"));else if("function"==typeof define&&define.amd)define(["underscore","backbone"],e);else if("undefined"!=typeof _&&"undefined"!=typeof Backbone){var t=Backbone.PageableCollection,i=Backbone.PageableCollection=e(_,Backbone);Backbone.PageableCollection.noConflict=function(){return Backbone.PageableCollection=t,i}}})(function(e,t){"use strict";function i(t,i){if(t*=1,!e.isNumber(t)||e.isNaN(t)||!e.isFinite(t)||~~t!==t)throw new TypeError("`"+i+"` must be a finite integer");return t}function r(){var t=arguments[0],i=e.toArray(arguments).slice(1),r=t.comparator;t.comparator=null;try{t.reset.apply(t,i)}finally{t.comparator=r,r&&t.sort()}return t}var a=/[\s'"]/g,s=/[<>\s'"]/g,o=t.Collection.extend({state:{firstPage:1,lastPage:null,currentPage:null,pageSize:25,totalPages:null,totalRecords:null,sortKey:null,order:-1},mode:"server",queryParams:{currentPage:"page",pageSize:"per_page",totalPages:"total_pages",totalRecords:"total_entries",sortKey:"sort_by",order:"order",directions:{"-1":"asc",1:"desc"}},initialize:function(t,i){i=i||{};var r=this.mode=i.mode||this.mode||n.mode,a=e.extend({},n.queryParams,this.queryParams,i.queryParams||{});a.directions=e.extend({},n.queryParams.directions,this.queryParams.directions,a.directions||{}),this.queryParams=a;var s=this.state=e.extend({},n.state,this.state,i.state||{});if(s.currentPage=null==s.currentPage?s.firstPage:s.currentPage,this.switchMode(r,e.extend({fetch:!1,resetState:!1,models:t},i)),"client"==r){null!=s.totalRecords||e.isEmpty(t)||(s.totalRecords=t.length),this.state=this._checkState(s);var o=i.comparator;if(s.sortKey&&!o&&(o=this.makeComparator(s.sortKey,s.order,i)),o)if(i.full){var l=this.fullCollection;l.comparator=o,l.sort()}else this.comparator=o;t&&!e.isEmpty(t)&&(this.getPage(s.currentPage),t.splice.apply(t,[0,t.length].concat(this.models)))}else this.state=this._checkState(s);this._initState=e.clone(this.state)},_makeFullCollection:function(i,r){var a,s,o,n=["url","model","sync","comparator"],l=this.constructor.prototype,c={};for(a=0,s=n.length;s>a;a++)o=n[a],e.isUndefined(l[o])||(c[o]=l[o]);var h=new(t.Collection.extend(c))(i,r),u=this;for(a=0,s=n.length;s>a;a++)o=n[a],u[o]!==l[o]&&(h[o]=o);return h._onFullCollectionEvent=this._onFullCollectionEvent,h.on("all",h._onFullCollectionEvent,h),h.pageableCollection=this,h},_onPageableCollectionEvent:function(t,i,a,s){var o=this.fullCollection;this.off("all",this._onPageableCollectionEvent,this),o.off("all",o._onFullCollectionEvent,o);var n=e.clone(this.state),l=0===n.firstPage?n.currentPage:n.currentPage-1,c=n.pageSize,h=l*c,u=h+c;if("add"==t){var f=h+this.indexOf(i);o.add(i,e.extend({},s||{},{at:f})),this.pop(),n.totalRecords++}if("remove"==t){var d=o.at(u);d&&this.push(d),o.remove(i),--n.totalRecords||(n.totalRecords=null,n.totalPages=null)}if("reset"==t){var g=o.models.slice(0,h),p=o.models.slice(h+this.models.length);r(o,g.concat(this.models).concat(p)),r(this,o.models.slice(h,u),{silent:!0}),n.totalRecords=o.models.length}this.state=this._checkState(n),o.on("all",o._onFullCollectionEvent,o),this.on("all",this._onPageableCollectionEvent,this)},_onFullCollectionEvent:function(t,i,a,s){var o=this.pageableCollection;this.off("all",this._onFullCollectionEvent,this),o.off("all",o._onPageableCollectionEvent,o);var n=e.clone(o.state),l=0===n.firstPage?n.currentPage:n.currentPage-1,c=n.pageSize,h=l*c,u=h+c;if("add"==t){var f=this.indexOf(i);if(f>=h&&u>f){var d=f-h;o.pop(),o.add(i,e.extend({},s||{},{at:d}))}n.totalRecords++}if("remove"==t){if(s.index>=h&&u>s.index){o.remove(i);var g=this.at(u);g&&o.push(g)}--n.totalRecords||(n.totalRecords=null,n.totalPages=null)}("reset"==t||"sort"==t)&&(s=a,r(o,this.models.slice(h,u),s),n.totalRecords=this.models.length),o.state=o._checkState(n),o.on("all",o._onPageableCollectionEvent,o),this.on("all",this._onFullCollectionEvent,this)},_checkState:function(e){var t=e.totalRecords,r=e.pageSize,a=e.currentPage,s=e.firstPage,o=e.totalPages;if(null!=t&&null!=r&&null!=a&&null!=s){if(t=i(t,"totalRecords"),r=i(r,"pageSize"),a=i(a,"currentPage"),s=i(s,"firstPage"),1>r||r>t)throw new RangeError("`pageSize` must be 1 <= pageSize <= totalRecords");if(null==o&&(o=e.totalPages=Math.ceil(t/r)),o=e.totalPages=Math.ceil(t/r),0===s){if(s>a||a>=o)throw new RangeError("`currentPage` must be firstPage <= currentPage < totalPages if 0-based.")}else{if(1!==s)throw new RangeError("`firstPage must be 0 or 1`");if(s>a||a>o)throw new RangeError("`currentPage` must be firstPage <= currentPage <= totalPages if 1-based.")}e.lastPage=0===s?o-1:o}return e},setPageSize:function(t,r){return t=i(t,"pageSize"),r=r||{},this.state=this._checkState(e.extend({},this.state,{pageSize:t,totalPages:"client"==this.mode?Math.ceil(this.fullCollection.size()/t):Math.ceil(this.state.totalRecords/t)})),this.getPage(this.state.currentPage,r)},switchMode:function(t,i){if(!e.contains(["server","client","infinite"],t))throw new TypeError('`mode` must be one of "server", "client" or "infinite"');i=i||{fetch:!0,resetState:!0};var r;return this.state=i.resetState?e.clone(this._initState):this._checkState(e.extend({},this.state)),"client"==t?(this.links&&delete this.links,r=this.fullCollection=this._makeFullCollection(i.models||[]),r.comparator=this._fullComparator,this.on("all",this._onPageableCollectionEvent,this)):this.fullCollection&&(r=this.fullCollection,r.off("all",r._onFullCollectionEvent,r),this.off("all",this._onPageableCollectionEvent,this),this._fullComparator=r.comparator,delete this.fullCollection,"server"==t&&this.links&&delete this.links),"infinite"==t&&(this.links={first:this.url,next:this.url}),i.fetch?this.fetch(e.omit(i,["fetch","resetState"])):this},getFirstPage:function(e){return this.getPage("first",e)},getPreviousPage:function(e){return this.getPage("prev",e)},getNextPage:function(e){return this.getPage("next",e)},getLastPage:function(e){return this.getPage("last",e)},getPage:function(t,r){r=r||{fetch:!1};var a=this.state,s=a.firstPage,o=a.currentPage,n=a.lastPage,l=a.pageSize,c=t;switch(t){case"first":c=s;break;case"prev":c=o-1;break;case"next":c=o+1;break;case"last":c=n;break;default:c=i(t,"index")}if(this.state=this._checkState(e.extend({},a,{currentPage:c})),"client"==this.mode&&!r.fetch){var h=(0===s?c:c-1)*l,u=h+l;return this.reset(this.fullCollection.models.slice(h,u))}if("infinite"==this.mode){var f=this.links;if(!f[t])throw new TypeError("No link found for '"+t+"'");var d=this;return this.fetch(e.extend({url:this.links[t]},r)).done(function(e,t,i){d.links=d.parseLinks(e,i)})}return this.fetch(r,"fetch")},parseLinks:function(t,i){var r=i.getResponseHeader("Link"),o=["first","prev","previous","next","last"],n={};return e.each(r.split(","),function(t){var i=t.split(";"),r=i[0].replace(s,""),l=i.slice(1);e.each(l,function(t){var i=t.split("="),s=i[0].replace(a,""),l=i[1].replace(a,"");"rel"==s&&e.contains(o,l)&&("previous"==l?n.prev=r:n[l]=r)})}),n},parse:function(t){if(!e.isArray(t))return new TypeError("The server response must be an array");if(2===t.length&&e.isObject(t[0])&&e.isArray(t[1])){var i=this.queryParams,r=e.clone(this.state),a=t[0];return e.each(e.pairs(e.omit(i,"directions")),function(e){var t=e[0],i=e[1];r[t]=a[i]}),a.order&&(r.order=1*e.invert(i.directions)[a.order]),this.state=this._checkState(r),t[1]}return t},fetch:function(i){i=i||{};var r=i.data=i.data||{};if("infinite"==this.mode&&!i.url)return this.getNextPage();var a,s,o,l,c=this._checkState(this.state),h="client"==this.mode?e.pick(this.queryParams,"sortKey","order"):e.omit(e.pick(this.queryParams,e.keys(n.queryParams)),"directions"),u=e.pairs(h),f=e.clone(this);for(a=0;u.length>a;a++)s=u[a],o=s[0],l=s[1],l=e.isFunction(l)?l.call(f):l,null!=c[o]&&null!=l&&(r[l]=c[o]);c.sortKey&&c.order?r[h.order]=this.queryParams.directions[c.order+""]:c.sortKey||delete r[h.order];var d=e.pairs(e.omit(this.queryParams,e.keys(n.queryParams)));for(a=0;d.length>a;a++)s=d[a],l=s[1],l=e.isFunction(l)?l.call(f):l,r[s[0]]=l;var g=t.Collection.prototype;if("client"==this.mode){var p=this,P=i.success;return i.success=function(e,t,r){r=r||{},r.silent=i.silent,p.fullCollection.reset(e.models,r),P&&P(e,t,r)},g.fetch.call(this,e.extend({},i,{silent:!0}))}return g.fetch.call(this,i)},makeComparator:function(e,t){if(e=null==e?this.state.sortKey:e,t=null==t?this.state.order:t,e&&t){var i=function(i,r){var a,s=i.get(e),o=r.get(e);return 1===t&&(a=s,s=o,o=a),s===o?0:o>s?-1:1};return i}}}),n=o.prototype;return o});